# kdeui Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KSystemTray Class Reference

KDE System Tray Window class KDE System Tray Window class. More...

`#include <ksystemtray.h>`

Inheritance diagram for KSystemTray:

[legend]
Collaboration diagram for KSystemTray:

[legend]
List of all members.

## Signals

void | quitSelected ()
| Emitted when quit is selected in the menu.

## Public Member Functions

| KSystemTray (QWidget *parent=0, const char *name=0)
| Construct a KSystemTray widget just like any other widget.

## Protected Member Functions

void | mousePressEvent (QMouseEvent *)
| Reimplemented to provide the standard show/raise behaviour for the parentWidget() and the context menu.
void | mouseReleaseEvent (QMouseEvent *)
| Reimplemented to provide the standard show/raise behaviour for the parentWidget() and the context menu.
KPopupMenu * | contextMenu () const
| Access to the context menu.
virtual void | contextMenuAboutToShow (KPopupMenu *menu)
| Makes it easy to adjust some menu items right before the context menu becomes visible.
KActionCollection * | actionCollection ()

Easy access to the actions in the context menu Currently includes KStdAction::Quit and minimizeRestore

Since:
  3.1.

void | showEvent (QShowEvent *)
| Reimplemented for internal reasons.
void | enterEvent (QEvent *)
| Reimplemented for internal reasons.
virtual void | virtual_hook (int id, void *data)

## Detailed Description

KDE System Tray Window class KDE System Tray Window class.

This class implements system tray windows.

A tray window is a small window (typically 24x24 pixel) that docks into the system tray in the desktop panel. It usually displays an icon or an animated icon there. The icon serves as representative for the application, similar to a taskbar button, but consumes less screen space.

When the user clicks with the left mouse button on the icon, the main application window is shown/raised and activated. With the right mouse button, she gets a popupmenu with application specific commands, including "Minimize/Restore" and "Quit".

Docking happens magically when calling show(). The window undocks with either hide() or when it is destroyed.

KSystemTray inherits methods such as setPixmap() and setMovie() to specify an icon or movie (animated icon) respectively. It is designed to be usable "as is", without the need to subclass it. In case you need to provide something special (such as an additional popupmenu on a click with the left mouse button), you can subclass anyway, of course.

Having an icon on the system tray is a useful technique for daemon-like applications that may run for some time without user interaction but have to be there immediately when the user needs them. Examples are kppp, kisdn, kscd, kmix or knotes. With kppp and kisdn, the docked icon even provides real-time information about the network status.

Author:
  Matthias Ettrich <ettrich@kde.org>

Definition at line 63 of file ksystemtray.h.

## Constructor & Destructor Documentation

KSystemTray::KSystemTray | ( | QWidget * | parent = 0,
|  | const char * | name = 0
| ) |

Construct a KSystemTray widget just like any other widget.

The parent widget `parent` has a special meaning: Besides owning the tray window, the parent widget will dissappear from taskbars when it is iconified while the tray window is visible. This is the desired behaviour. After all, the tray window `is` the parent's taskbar icon.

Furthermore, the parent widget is shown or raised respectively when the user clicks on the trray window with the left mouse button.

Definition at line 63 of file ksystemtray.cpp.

References KStdAccel::close(), KWin::info(), KPopupMenu::insertTitle(), KIO::move(), KStdAccel::name(), KWin::Info::onAllDesktops, KStdAction::quit(), quitSelected(), KWin::setSystemTrayWindowFor(), and QWidget::topLevelWidget().

## Member Function Documentation

void KSystemTray::mousePressEvent | ( | QMouseEvent * |  | ) | `[protected]`

| Reimplemented to provide the standard show/raise behaviour for the parentWidget() and the context menu. Feel free to reimplement this if you need something special. Definition at line 154 of file ksystemtray.cpp. References KStdAccel::action(), QMouseEvent::button(), contextMenuAboutToShow(), QMouseEvent::globalPos(), QPopupMenu::popup(), and QMouseEvent::pos().

void KSystemTray::mouseReleaseEvent | ( | QMouseEvent * |  | ) | `[protected]`

| Reimplemented to provide the standard show/raise behaviour for the parentWidget() and the context menu. Feel free to reimplement this if you need something special. Definition at line 182 of file ksystemtray.cpp.

KPopupMenu * KSystemTray::contextMenu | ( |  | ) | const`[protected]`

| Access to the context menu. This makes it easy to add new items to it. Definition at line 148 of file ksystemtray.cpp.

void KSystemTray::contextMenuAboutToShow | ( | KPopupMenu * | menu | ) | `[protected, virtual]`

| Makes it easy to adjust some menu items right before the context menu becomes visible. Definition at line 187 of file ksystemtray.cpp. Referenced by mousePressEvent().

KActionCollection * KSystemTray::actionCollection | ( |  | ) | `[protected]`

Easy access to the actions in the context menu Currently includes KStdAction::Quit and minimizeRestore

Since:
  3.1.

Definition at line 254 of file ksystemtray.cpp.

void KSystemTray::showEvent | ( | QShowEvent * |  | ) | `[protected]`

| Reimplemented for internal reasons. Definition at line 102 of file ksystemtray.cpp. References KStdAccel::action(), and QPopupMenu::insertSeparator().

void KSystemTray::enterEvent | ( | QEvent * |  | ) | `[protected]`

| Reimplemented for internal reasons. Definition at line 125 of file ksystemtray.cpp.

void KSystemTray::quitSelected | ( |  | ) | `[signal]`

Emitted when quit is selected in the menu.

If you want to perform any other action than to close the main application window please connect to this signal.

Since:
  3.1

Referenced by KSystemTray().

The documentation for this class was generated from the following files:

- ksystemtray.h
- ksystemtray.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:04:54 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001